/*----------------------------------------------------------------------*
 * TLAtype.c
 *
 * Olaf Meier, 16.6.94
 *
 * Enthaelt die Member-Funktionen zu der Klasse TypeComp sowie einige Hilfsroutinen.
 *-------------------------------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h> 
#include <assert.h>
#include "tlatype.h"
#include "dbinterface.h"




/*-----------------------------------------------------------------------*
 * Klasse TypeComp
 *-----------------------------------------------------------------------*/


   TypeComp* TypeComp::GetTypeofTupleComp(int number)

   { 

     TypeComp* type = GetComp1();
     int index;
     if(number < 1) // erste Komponente muss mit 1 starten!
      return NULL;
     else
      {
       for(index=1 ; index < number; index++)
       { type = type->GetComp3();
         if(type == NULL)
	  return NULL;
       };

       return type;
      };
   }







   TypeComp* TypeComp::GetTypeofRecComp(char* comp)
   {
     assert(comp);

     TypeComp *typc3,*typc1;
     
     
     typc1 = GetComp1();
     if(strcmp(typc1->GetCompname(),comp) == 0)  // ...falls Struktur den Komponentennamen 'comp'
                                                 // besitzt
      return typc1;                              // ...Typ zurueckgeben
     else
     {
	typc3 = typc1->GetNextType();    // ... weitersuchen
	while(typc3 != NULL)
	  {
         if(strcmp(typc3->GetCompname(),comp) == 0)
		{

		  break;
		}
	     else
	       typc3 = typc3->GetNextType();
	  };
	return typc3;
     };
    }


  TypeComp* TypeComp::CopyRest()  // alle Typkomponenten werden kopiert.
    { 
      TypeComp *newtype = new TypeComp(type);
      if(compname) // Strukturkomponentennamen kopieren
       newtype->SetCompname(compname);

      if(parameter) // Name des globalen Parameters kopieren
       newtype->SetParname(parameter);

      if(comp1)
       newtype->SetComp1(comp1->CopyRest());

      if(comp2)
       newtype->SetComp2(comp2->CopyRest());

      if(comp3)
       newtype->SetComp3(comp3->CopyRest());

      if(ID_Type)
       newtype->SetID_Type(ID_Type);

      return newtype;
 }

   TypeComp* TypeComp::Copy()  // Typkomponente 'comp3' wird nicht kopiert.
    { 
      
      TypeComp *newtype = new TypeComp(type);
      
      if(compname)  // Strukturkomponentennamen kopieren

       newtype->SetCompname(compname);

      if(parameter) // Name des globalen Parameters kopieren

       newtype->SetParname(parameter);



      if(comp1)
       newtype->SetComp1(comp1->CopyRest());

      if(comp2)
       newtype->SetComp2(comp2->CopyRest());
      if(ID_Type)
       newtype->SetID_Type(ID_Type);

      return newtype;
   }


void TypeComp::PrintParameters()
 { TypeComp* t;
  
   PrintType();
   t = GetComp3();

   if(t != NULL)
    {
      SimpleWarningCont(",");
      t->PrintParameters();
      
    }
   
  };   

void TypeComp::PrintRecordComps()
 { 
   char* pn = new char[strlen(compname)+1];
   strcpy(pn, compname);
   TypeComp* t;
   
   SimpleWarningCont(pn);
   SimpleWarningCont(": ");
   PrintType();
   delete pn;
   t = GetComp3();
   if(t != NULL)
    {
     SimpleWarningCont(", ");
     t->PrintRecordComps();
    }
 }

void TypeComp::PrintTupleComps(int n)
 { 
   char *compnumber = new char[22];
   TypeComp* t;
   sprintf(compnumber,"comp %d: ", n);
   SimpleWarningCont(compnumber);
   PrintType();
   delete compnumber;
   t = GetComp3();
   n++;
   if(t != NULL)
    {
      SimpleWarningCont(", ");
      t->PrintTupleComps(n);
      
    } 
  }     
  
void TypeComp::PrintType()  // ohne 'newline' nach Typausgabe!
 {  TypeComp *t1, *t2;
    switch(type)
      {
        case ANY_type      : SimpleWarningCont("ANY"); break;

        case UNKNOWN_type  : SimpleWarningCont("UNKNOWN");break;
        case NATNUM_type   : SimpleWarningCont("NATNUM"); break;

        case STRING_type   : SimpleWarningCont("STRING");break;
        case REAL_type     : SimpleWarningCont("REALNUM"); break;
        case EMPTYSET_type : SimpleWarningCont("EMPTYSET"); break;
        case OPERATOR_type : SimpleWarningCont("OPERATOR((");
                             
                             t1 = GetComp1();
                             t1->PrintParameters();
                             SimpleWarningCont("):");
                             t2 = GetComp2();
                             t2->PrintParameters();
                             SimpleWarningCont(")");
                             break;   
        case ARRAY_type    : SimpleWarningCont("ARRAY(");
                             
                             t1 = GetComp1();
                             t1->PrintParameters();
                             SimpleWarningCont(" --> ");
                             t2 = GetComp2();
                             t2->PrintParameters();
                             SimpleWarningCont(")");
                             break;
                            
        case TUPLE_type    : SimpleWarningCont("TUPLE(");
                             t1 = GetComp1();
                             t1->PrintTupleComps(1);
                             SimpleWarningCont(")");

                             break;
        case SET_type      : SimpleWarningCont("SET of(");
                             t1 = GetComp1();
                             t1->PrintType();
                             SimpleWarningCont(")");
                             break;
        case SUBSET_type   : SimpleWarningCont("SUBSET of(");
                             t1 = GetComp1();
                             t1->PrintParameters();
                             SimpleWarningCont(")");
                            
                             break;
        case ENUMSET_type     : SimpleWarningCont("ENUMSET(");
                             t1 = GetComp1();
                             t1->PrintParameters();
                             SimpleWarningCont(")");

                             break;
        case UNION_type    : SimpleWarningCont("UNION of(");
                             t1 = GetComp1();
                             t1->PrintParameters();
                             SimpleWarningCont(")");                            
                             break;
        case RECORD_type   : SimpleWarningCont("RECORD(");
                             t1 = GetComp1();
                             t1->PrintRecordComps();
                             SimpleWarningCont(")"); 
                             break;
        case ID_type       : SimpleWarningCont("?ID?"); break;
        case BOOLEAN_type  : SimpleWarningCont("BOOLEAN"); break;
        case JOKER_type    : SimpleWarningCont("systemvariable of unspecified type !");  
      };
   
 }        

void TypeComp::PrintType_nl()
 {
   PrintType();
   SimpleWarningCont("\n");
 }


TypeComp* GetElementofType(TypeComp* type)
 { 
   TypeComp *typ, *typ1, *typ2;
   char* parname ;
   TLA_Type tp ;
   if(type == NULL)
    { typ = new TypeComp(UNKNOWN_type);
      return typ;
    }
   else
    {
     if(type->GetParname() != NULL)
      parname = type->GetParname();
     else 
      parname = NULL; 
     tp = type->GetType();
     switch(tp)
     {

     case SET_type : typ = type->GetComp1();
                     typ = typ->Copy();
                     typ->SetParname(parname); 
                     return typ;
     case SUBSET_type : typ = type->GetComp1();
                        typ = typ->Copy();
                        typ->SetParname(parname); 
                        return typ;
     case UNION_type : typ = new TypeComp(UNION_type); // Hier muessen die einzelnen Typen betrachtet
                                                       // werden. Die einzelnen Elemente aus diesen
                                                       // werden wieder durch den UNION_typ verkunuepft
                       type = type->GetComp1();
                       typ2 = GetElementofType(type);
                       typ->SetComp1(typ2);
                       type = type->GetNextType();
                       while(type != NULL)
                       {
                         typ1 = GetElementofType(type);
                         typ2->SetComp3(typ1);
                         typ2 = typ1;
                         type = type->GetNextType();
                       };
                       typ->SetParname(parname);
                       return typ;

     case ENUMSET_type : typ = new TypeComp(UNION_type);
                         type = type->GetComp1();
                         typ2 = type->CopyRest();
                         typ->SetComp1(typ2);
                         type = type->GetNextType();
                         while(type != NULL)
                         {
                         typ1 = type->CopyRest();
                         typ2->SetComp3(typ1);
                         typ2 = typ1;
                         type = type->GetNextType();
                       };
                       typ->SetParname(parname);
                       return typ; 



     case ANY_type : typ = new TypeComp(ANY_type); // Element von einem beliebigen Typ ist wieder ein
                                                   // beliebiger Typ
                     typ->SetParname(parname);						  
                     return typ;

     case UNKNOWN_type : typ = new TypeComp(UNKNOWN_type); // Element von einem unkorrekten Typ
                                                           // ist wieder ein unkorrekter Typ
                         typ->SetParname(parname);
                         return typ;


     default :    typ = new TypeComp(UNKNOWN_type);
                  typ->SetParname(parname);
  
                  return typ;
    };
   }
 }






   void TypeComp::TraverseTypeInfo(char* par, TypeComp* typ)
    { assert(par && typ);
  
      char *name;
     
     if(GetParname()!= NULL )
      { name = GetParname();
        if(strcmp(name, par) == 0)  // Parameter in Typinformation gefunden !
         { 
           typ = typ->Copy();
           if(GetComp1() != NULL)
            delete GetComp1();
           if(GetComp2() != NULL)
            delete GetComp2();
           SetType(typ->GetType());
	   if(typ->GetComp1() != NULL)
	    SetComp1(typ->GetComp1());
	   if(typ->GetComp2() != NULL)
	    SetComp2(typ->GetComp2());
           if(typ->GetParname() != NULL)
            SetParname(typ->GetParname());
           else
            SetParname(NULL);
          }
        else
         {
        if(GetComp1() != NULL)
         GetComp1()->TraverseTypeInfo(par,typ);
        if(GetComp2() != NULL)
         GetComp2()->TraverseTypeInfo(par,typ);
        if(GetComp3() != NULL)
         GetComp3()->TraverseTypeInfo(par,typ);          
         };
      }
      else
       
      { if(GetComp1() != NULL)
	 GetComp1()->TraverseTypeInfo(par,typ);
	if(GetComp2() != NULL)
	 GetComp2()->TraverseTypeInfo(par,typ);
	if(GetComp3() != NULL)
	 GetComp3()->TraverseTypeInfo(par,typ);
      };
 }


TypeComp* GetLastType(TypeComp* typ)
 {  assert(typ);
    
    TypeComp *t1, *t2;
    t1 = typ;
    t2 = t1->GetNextType();
    while(t2)
    { t1 = t2;
      t2 = t2->GetNextType();
    };
    return t1;
  }



TypeComp* GetARRAY(TypeComp* type)
{
  


  if(!type)
   return NULL;
  else
  {
    TLA_Type tp = type->GetType();
    switch(tp)
    { case ARRAY_type : return type;



      default  : return NULL;
    };
  };
 }


TypeComp* GetTUPLE(TypeComp* type, int num = 0)
{
  

  TypeComp *typ1, *typ2 = NULL ;
  if(!type)
   return NULL;
  else
   {
     TLA_Type tp = type->GetType();
     switch(tp)
      {

        case TUPLE_type : if(num)   // fall num <> 0 angegeben !
                       return type->GetTypeofTupleComp(num); // gebe typ der 'num'ten Komponente zurueck
                      else
                       return type;
        case UNION_type : typ1 = type->GetComp1(); // die verknuepften Typen werden einzeln
                                                   // untersucht, bis passender Typ gefunden wurde
                             while((typ1 != NULL)&&(typ2 == NULL))
                             { if(typ1->GetType() == TUPLE_type)
                                { if(num)
                                    typ2 = typ1->GetTypeofTupleComp(num);
                                  else
                                   typ2 = typ1;
                                 }
                               else
                                {
                                  typ1 = typ1->GetNextType();
                                  typ2 = NULL;
                                };
                              };
                             return typ2;

        default  : return NULL;
       };
   };
}


TypeComp* GetRECORD(TypeComp* type,char* comp = NULL)
{
  

  TypeComp *typ1, *typ2 = NULL  , *typ3;
  if(!type)
   return NULL;
  else
   {
      TLA_Type tp = type->GetType();
      switch(tp)
       {

         case RECORD_type : if(comp) // falls Komponentenname angegeben wurde
                        return type->GetTypeofRecComp(comp); // gebe Typ der Komponente 'com' zurueck
                       else
                        return type;
         case UNION_type :   typ1 = type->GetComp1(); // die verkuepften Type werden einzeln untersucht
                                                      // bis passender Typ gefunden wurde
                             while((typ1 != NULL)&&(typ2 == NULL))
                             { if(typ1->GetType() == RECORD_type)
                                { if(comp)
                                    typ2 = typ1->GetTypeofRecComp(comp);
                                  else
                                   typ2 = typ1;
                                 }
                               else
                                {
                                  typ1 = typ1->GetNextType();
                                  typ2 = NULL;
                                };
                              };
                             return typ2;

         default  : return NULL;
       };
   };

}
