CONSTANT MODULE Bank
(* originally from Lamports 9/91 TLA+ text, adapted to             *)
(* 2/92 and to Dortmund-Syntax: Mester, 8.7.92; Geikowski, 18.5.93 *)

EXPORT Outcome
       OPAQUE  Ledger, NewLedger, Deposit, Withdraw, Balance;

INCLUDE  FullTables  AS Tab  WITH Item        <- Nat,
                                  InitialItem <- 0;
  
CONSTANTS
  Ledger  ==  Tab.Table;

  NewLedger : Ledger ==  Tab.NewTable;

  Outcome  ==  {"OK", "Error"};

  Balance(n : Name; L : Ledger) : Nat  ==  Tab.LookUp(n, L) ; 
  
  Deposit(n : Name; d : Nat; L : Ledger) : Ledger  ==
      Tab.Insert(n, Balance(n,L) + d, L);
  
  Withdraw(n : Name; 
           w : Nat; 
           L : Ledger  ) : Outcome :X: Ledger  ==
      IF  Balance(n,L) < w 
      THEN  ("Error", L)
      ELSE  ("OK", Tab.Insert(n, Balance(n , L) - w, L))  
  ;

CONSTANT THEOREMS
  BankTypeOK  == :A: n :in: Name; L :in: Ledger
                    :: 
                       /\ Balance(n , L) :in: Nat
                       /\ :A: m :in: Nat
                             :: 
                                /\ Deposit(n, m, L)  :in: Ledger
                                /\ Withdraw(n, m, L) :in: Outcome :X: Ledger
  ;

END
