MODULE BankInterface 
(* originally from Lamports 9/91 TLA+ text, adapted to             *)
(* 2/92 and to Dortmund-Syntax: Mester, 1.7.92; Geikowski, 24.5.93 *)

PARAMETERS
  ATM  : Any CONST ;                 (* The set of ATM names                *)
  aToB : AtoB.Type STATE FUNCTION ;  (* An array of wires from ATMs to bank *)
  bToA : BtoA.Type STATE FUNCTION ;  (* An array of wires from bank to ATMs *)
  Name : Any CONST ;                 (* The set of customer names           *)

CONSTANTS    (* The sets of messages sent by the ATMs and by the bank. *)
  ATMMessage  == 
    [[nam : Name; req : {"Deposit", "Withdraw"}; amt : Nat]] :cup:
    [[nam : Name; req : {"Balance?"}]]
  ;
  BankMessage  ==  {"OK", "Error"} :cup: Nat ;
  
INCLUDE  WireArrays AS AtoB WITH Item  <- ATMMessage,
                                 Name  <- ATM,
                                 wires <- aToB ;
         WireArrays AS BtoA WITH Item  <- BankMessage,
                                 Name  <- ATM,
                                 wires <- bToA ;

PREDICATES
    Init    ==  AtoB.Init /\ BtoA.Init
    ;
    TypeOK  ==  aToB :in: AtoB.Type /\ bToA :in: BtoA.Type
    ;

END
