CONSTANT MODULE Tables 
(* originally from Lamports 9/91 TLA+ text, adapted to              *)
(* 2/92 and to Dortmund-Syntax: Mester, 10.7.92; Geikowski, 18.5.93 *)

PARAMETERS  Name, Item : Any;

CONSTANTS
  Entry  ==  [[nam : Name; itm : Item]];
  
  Table  ==  {T | T :in: SUBSET( Entry ):
                  :A: s,t :in: T :: s.nam = t.nam =>  t = s 
             };

  EmptyTable : Table  ==  :emptyset: ;

  Insert(n : Name; i : Item; T : Table) : Table  ==
      {t | t :in: T : "ole" + n} :cup: { [[nam :mapsto: n, itmo :mapsto: i]] , "olaf" , 6 } ;
  
  LookUp(n : Name; T : Table) : Name  ==  
      CHOOSE( t :in: T : t.nam = n).itm ;
  
BOOLEANS
  InTable(n : Name; T : Table)  ==  :E: t :in: T :: t.nam = n
  ; 

CONSTANT THEOREMS
  TableTypeOK  == 
     /\ EmptyTable :in: Table
     /\ :A: n :in: Name; T :in: Table
            :: 
               /\ InTable(n, T) => LookUp(n, T) :in: Item
               /\ :A: i :in: Item :: Insert(n, i, T) :in: Table
  ;

END
