TEMPORAL MODULE SeqDiscovery

  PARAMETERS Node      : Any           CONSTANT;
             Edge      : Node :X: Node CONSTANT;
             Initiator : Node          CONSTANT; 

  INCLUDE SeqDiscoveryActions AS SDA(AC,TS,MB,MS,WO)
     WITH Active    <- AC,
          ToScan    <- TS,
          MBox      <- MB,
          Master    <- MS,
          WaitingOf <- WO,
          Node      <- Node,
          Edge      <- Edge,
          Initiator <- Initiator;

  TEMPORAL THEOREMS
    SeqDiscovery == 
      :EE: AC,TS,MB,MS,WO
       :: /\ SDA(AC,TS,MB,MS,WO).Init
          /\ [] ( [ :E: v,w :in: Node
                     :: \/ SDA(AC,TS,MB,MS,WO).SendScan(v,w)
                        \/ SDA(AC,TS,MB,MS,WO).ReceiveFirstScan(v)
                        \/ SDA(AC,TS,MB,MS,WO).ReceiveSucc(v,w)
                        \/ SDA(AC,TS,MB,MS,WO).ReceiveAnswer(v)
                        \/ SDA(AC,TS,MB,MS,WO).NonInitiatorTermination(v)
                        \/ SDA(AC,TS,MB,MS,WO).InitiatorTermination(v)
                  ] _ (AC,TS,MB,MS,WO)
                )
          /\ :A: v,w :in: Node 
              :: /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).SendScan(v,w) )
                 /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).ReceiveFirstScan(v) )
                 /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).ReceiveSucc(v,w) )
                 /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).ReceiveAnswer(v) )
                 /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).InitiatorTermination(v) )
                 /\ WF [ (AC,TS,MB,MS,WO) ] 
                       ( SDA(AC,TS,MB,MS,WO).NonInitiatorTermination(v) )
    ;

END SeqDiscovery
